Subject: Re: [bug#27791] [PATCH] gnu: Add passmenu
From: Jelle Licht <[email-masked]>
To: [email-masked]
Cc: Ludovic Courtès <[email-masked]>, Jelle Licht <[email-masked]>, Marius Bakke <[email-masked]>
Date: Fri, 10 Nov 2017 14:50:08 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

In the end, I simply added dmenu to the list of `inputs' and replaced my
calls to `wrap-program' with a `substitute*' call. Pushed as 177475cfb5
to master.

Someone wanting to make use of an alternative to dmenu could just
inherit from `password-store' in order to override the relevant inputs
and/or phases. The closure size of password-store went from ~421MB to
~440MB, but as it is not a dependency of any non-password-store related
items, this should not be a big problem.

Thanks again for the guidance and reminders.

Marius Bakke <[email-masked]> writes:

> Jelle Licht <[email-masked]> writes:
>
>> Ludovic Courtès <[email-masked]> writes:
>>
>>> Hi Jelle,
>>>
>>> Is anything holding this back?
>>>
>>>   https://bugs.gnu.org/27791
>>
>> It just fell through the cracks, thanks for reminding me :-).
>> I still needed to address some of Marius' concerns though...
>>
>>>
>>> TIA!  :-)
>>>
>>> Ludo’.
>>>
>>> Marius Bakke <[email-masked]> skribis:
>>>
>>>> Hi Jelle,
>>>>
>>>> Jelle Licht <[email-masked]> writes:
>>>>
>>>>> Hello guix,
>>>>>
>>>>> Attached is a patch to include passmenu, a dmenu interface to the pass
>>>>> password store.
>>>>>
>>>>> I was not quite sure how to structure this patch, as it basically installs
>>>>> and wraps a shell script from the `password-store' sources. We could
>>>>> instead include it as a separate output of our `password-store' package,
>>>>> but I already had it like this in my GUIX_PACKAGE_PATH and I was not even
>>>>> sure if that approach was in general preferable.
>>>>
>>>> I don't think wrapping it with dmenu in PATH is necessary. Users of this
>>>> script are expected to have dmenu from before, and may want to use
>>>> another implementation (e.g. rofi), another version, etc.
>>
>> While I agree with your general thoughts, wasn't guix supposed to
>> prevent this ad-hoc mishmash of software? If someone wants to use
>> another implementation (e.g. rofi), they could just create their own
>> package that inherits from `password-store' and overrides the "dmenu"
>> input. Case in point, I am not currently a user of dmenu (besides
>> indirectly through the passmenu script).
>
> In the "rofi" case it would be overriding dmenu and providing some extra
> command-line arguments, but overall I agree with you and don't really
> have a strong opinion.  To my knowledge there is no established policy
> for when to allow "impurities" (aka unqualified paths), but optional
> dependencies often get a free pass.
>
> I'm happy either way, so do what you think is best :)